#include "main.h"

//FEATURES:
//=========
//Special Statuses:     DEFENSE Stats (wears off after afflicted does an action),
//                      MultiAction Status (fills the ATB after one action, giving instant second action),
//                      Slow/Fast Statuses (changes ATB gain values)*,
//                      No-MP Death "Status" (special death if MP=0 for all battlers)
//
//ATB Controls:         ATB Wait mode can be de/activated by switch.
//                      ATB Gain value and speed can vary changing a variable value.
//
//Special Skills:       DoubleAttack Skill
//                      TODO- Scan Skill (drawing stuff on screen rather than using speechboxes or animations)
//                      TODO- Special formula skills (damage and effects being specific for certain skills)
//
//Other stuff:          No-Fullscreen
//                      Fullscreen/DoubleResolution changes using switches

//Asdf: RPG::Actor->partyMember[index]; -- RPG::monsters[index]; aww yeah!!!

int hero_active = 0;
bool window_active;
bool selection_active;

bool onDoBattlerAction (RPG::Battler *battler){
    //Altered stats Experimental "features" 1 (?).
    battler->conditions[25] = 0; //Shield1 status: when a different action is done...
    battler->conditions[26] = 0; //Shield2 status: ...all "shield" statuses are removed.
    //bool isMonster = battler->isMonster();

    if (battler->action->kind==RPG::AK_SKILL) {
        //When skill 220 is used, changes the action to Double Attack
        if (battler->action->skillId==220){
            battler->action->kind = RPG::AK_BASIC;
            battler->action->basicActionId = RPG::BA_DOUBLE_ATTACK;
        }else {
            switch (battler->action->skillId)
            {
                case 219:
                    //TODO: saving "basic" damage data and setting all to know who is the target.
                    break;
            }

            //Next step: on target battler drawing, checking if he's target, and doing the stuff on him.
        }
    }

    return true;
}

bool onBattlerActionDone (RPG::Battler *battler, bool success){
    //Altered stats Experimental "features" 2 (?).
    if(battler->conditions[41] > 0) {
        if (battler->atbValue < 299999){
            battler->atbValue = 299999; //Multi-action status
            battler->conditions[41] = 0;
        }
    }
    return true;
}

bool onDrawBattler(RPG::Battler *battler, bool isMonster, int id) {

    return true;
}

// This handler is called after a battler is drawn
bool onBattlerDrawn(RPG::Battler *battler, bool isMonster, int id) {
    int totalBoost = 0;
    if (!selection_active || !window_active){
        totalBoost += 100;
    }
    //part of this code is Cherry's... but anyway, this was the first test that i did that WORKED!! ahahahaha!
    // We loop through all the elements of the battler's "conditions" array here
    for(int i = 1; i <= battler->conditions.size; i++) {
        // If the battler has the condition (turns elapsed higher than zero)...
        //Because the thing that makes a battler get a condition is that. Turns being higher than zero.
        if(battler->conditions[i] > 0) {
            if (i == 28){ //this is my "fast" state id...
                //this is here because high speed at windows, even if active mode... it's kind of a nuisance...
                //better if active just makes it to just not wait, but instead to be slower.
                if (!selection_active || !window_active){ //checks if you're selecting target or have some action window opened.
                    totalBoost += 100; //the boost is later on multiplied by the battle speed
                }
            }else if (i == 18){ //and this is the one for my slow...
                if (!selection_active || !window_active){ //by the way, these checkings are defined below...
                    totalBoost -= 50; //the boost is later on multiplied by the battle speed
                }
            }
        }
    }
    totalBoost *= (RPG::variables[369]+1); //and now, boost is multiplied by a variable (SO try to not make that variable some insane value!)
    battler->atbValue += totalBoost; //and this is the actual sum to the battler atbvalue.
    if (battler->atbValue > 300000){
        battler->atbValue = 300000; //max atbValue is 300000. The normal proccess makes this step by itself. But this code doesn't.
    }
    if (battler->mp<=0 && battler->conditions[42]==0){
        battler->animationId = 5;
        battler->conditions[42] = 1;
        battler->damagePopup ("Dried");
        battler->damagePopupTimer = 120;
        pauseBattle();
        /*do{
            RPG::updateBattle();
            battler->damagePopupTimer--;
        }while(battler->damagePopupTimer != 0);*/
    }
    if (isMonster == true && battler->mp<=0 && battler->conditions[42]!=0){ //
        RPG::Monster *monster = (RPG::Monster *)battler; // First, we cast the "battler" to a "Monster"
        monster->image->alpha = (battler->damagePopupTimer);
        if (battler->damagePopupTimer<=0){
            battler->hp = 0;
            unpauseBattle();

        }
    }
    return true; // It's okay that the battler is drawn, so we return true. Don't forget that!
}

bool onDrawBattleStatusWindow (int x, int selection, bool selActive, bool isTargetSelection, bool isVisible){
    selection_active = isTargetSelection; //we store if player is selecting a target or not.
    if (!isTargetSelection){
        hero_active = selection;    //and we store the active hero too.
    }
    return true;
}

bool onDrawBattleActionWindow (int *x,int *y,int selection,bool selActive,bool isVisible){

    window_active = isVisible; //here we save if this window is being displayed.
    /*if (window_active == true){
        if (selActive==true){
            *x = 80 * hero_active;
            *y = 40;
        }else{
            *x = 0;
            *y = 240;
        }
    }*/
    return true;
}

// Handler called on startup
bool onStartup(char *pluginName){
    *reinterpret_cast<short *>(0x48FA57) = 0x9090;
    return true;
}

bool onSetSwitch(int id, bool value) {
    if (id == 369){
        if (value == true){
            RPG::system->atbMode = RPG::ATBM_ACTIVE;

        }else{
            RPG::system->atbMode = RPG::ATBM_WAIT;
        }

    }
    if (id == 368){
        keybd_event(VK_F4, 0, 0, 0); // simulate F4 key down
        keybd_event(VK_F4, 0, KEYEVENTF_KEYUP, 0); // simulate F4 key up
    }
    if (id == 367){
        keybd_event(VK_F5, 0, 0, 0); // simulate F5 key down
        keybd_event(VK_F5, 0, KEYEVENTF_KEYUP, 0); // simulate F5 key up
    }
    return true;
}

void unpauseBattle(){
    RPG::battleSpeed = 50 + RPG::variables[369]*10;
}

void pauseBattle(){
    RPG::battleSpeed = 0;
}
